# Test scripts

These python scripts were made to be able to create, extract, visualize, and play back signals that are meant to be played on the haptic floor.

All these scripts either processes json files or converts from json to another format or from another format to json.

json files were chosen because they are easy to read and edit for a human and they are widely supported by many programming languages and tools.

## To install the dependencies

This command will install the dependencies for all the scripts.

`pip install -r requirements.txt`

## I just want to visualize a signal sent to the floor

By using these scripts, it is possible to dump and visualize the signal that was sent to the first channel of the floor.

1. First, start mmesh with the --debug flag and dump its output in a file. Your command may look a bit like this : `mmesh osc --ip 127.0.0.1 --port 9000 --debug > my_debug_dump`
2. Use the `mmesh_debug_to_json.py` script to convert the debug dump to a json signal file : `python mmesh_debug_to_json.py <path_to>/my_debug_dump my_debug_signal.json`
3. (optionnal) If the signal is very long, the visualization may be a bit too zoomed out. You can manually edit the file to make it shorter by removing some values from the array.
4. Visualize the signal with the visualization script `python visualize_signal_json.py my_debug_signal.json`

You could also use the `signal_json_to_pcm.py` to create a wav file and then look at a spectrogram of the signal or use the `replay_signal_json.py` to send the signal back to the floor.

## Overview of the scripts

### make_test_signals.py

This script will generate a json signal file of varying shapes at varying frequencies and amplitude. Run the script without parameters to
get an overview of the available parameters.

### mmesh_debug_to_json.py

This script takes a dump of mmesh debug output and will process it to make a json signal file of the motion data for the first of the 4 motion channels.

This can be useful to visualize what mmesh actually sends to the floor.

### replay_signal_json.py

This script takes a json signal file and replays its content as OSC messages sent at 400hz in a loop to a given ip address and port.

This can be used to play signals back to mmesh. The signal will be duplicated on all channels and the number of channels sent is parametrizable.

### signal_json_to_pcm.py

This script takes a json signal and transforms it to a PCM (.wav) file. This can be useful to visualize the scectrum of the signal
in a tool surch as sonic visualizer.

### visualize_signal_json.py

This script takes a json signal file and creates a graph of the signal. The default graphs are position, speed and acceleration.
By default, the signals are converted to the physical values of the movement : a signal from -1 to 1 will be translated to the position
in mm that a DBOX actuator will have when a signal of that value is played.

run this without arguments to get a summary of the parameters.

### move_floor_with_keyboard.py

This script allows sending OSC messages to the floor by using the computer's keyboard. Number keys from 0 to 9 will send values from -1 to 1 in float
to as many channel as desired (default is 4). This can be used to test the interaction latency of the floor.

### mmesh_pipe_osc.py

A tool that takes `f32le` binary samples from `stdin` and sends them to mmesh over OSC `/signal` messages.

### Test sending a sinus generated by GStreamer

```
gst-launch-1.0 --quiet \
	audiotestsrc \
		is-live=true \
		wave=sine \
		freq=0.2 \
		volume=1.0 \
		samplesperbuffer=4 \
	! audio/x-raw,format=F32LE,layout=interleaved,rate=400,channels=4 \
	! fdsink \
	| test_scripts/mmesh_pipe_osc.py --channels 4 --address 10.10.33.155
```

### Send audio from PulseAudio to mmesh

Create a new virtual loopback audio interface using `pactl`. This shows as new Output Device named `Haptic Floor Output (4ch)`.

```
pactl load-module \
    module-null-sink \
    sink_name=haptic-floor \
    sink_properties=\"device.description=\'Haptic Floor Output \(4ch\)\' device.icon_name=\'network-server\'\" \
    channels=4
```

Start audio to OSC bridge.

```
gst-launch-1.0 --quiet \
	pulsesrc \
		client-name="Haptic Floor OSC bridge" \
	! audio/x-raw,format=F32LE,layout=interleaved,rate=400,channels=4 \
	! fdsink \
	| test_scripts/mmesh_pipe_osc.py --channels 4 --address 10.10.33.155
```

Open PulseAudio mixer GUI (`pavucontrol`).

In Recording tab, select `Monitor of Haptic Floor Output (4ch)` option in `Record Stream from` of `Haptic Floor OSC bridge` client.

In Playback tab, assign `Haptic Floor Output (4ch)` to your playing application.